summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorP. J. McDermott <pj@pehjota.net>2015-10-28 09:46:07 (EDT)
committer P. J. McDermott <pj@pehjota.net>2015-10-28 09:46:07 (EDT)
commit1a3857c907b5b98097162330b2dc792c39879dd3 (patch)
tree5e9f1c40a5ea84d54244187f969280ffb4c4a3d4
parent0a94d7cce10277b285beacf2d2a0a88ef1f501ea (diff)
downloadfirman.sh-1a3857c907b5b98097162330b2dc792c39879dd3.zip
firman.sh-1a3857c907b5b98097162330b2dc792c39879dd3.tar.gz
firman.sh-1a3857c907b5b98097162330b2dc792c39879dd3.tar.bz2
src/rand.sh: New file
-rw-r--r--src/local.mk1
-rw-r--r--src/rand.sh44
2 files changed, 45 insertions, 0 deletions
diff --git a/src/local.mk b/src/local.mk
index e6679af..0ce1d77 100644
--- a/src/local.mk
+++ b/src/local.mk
@@ -3,6 +3,7 @@ firman_SOURCES += \
src/dist.sh \
src/flashrom.sh \
src/main.sh \
+ src/rand.sh \
src/ui.sh
include $(top_srcdir)/src/action/local.mk
diff --git a/src/rand.sh b/src/rand.sh
new file mode 100644
index 0000000..160e49e
--- /dev/null
+++ b/src/rand.sh
@@ -0,0 +1,44 @@
+# Linear congruential pseudorandom number generator
+#
+# Copyright (C) 2014 Patrick "P. J." McDermott
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+rand_x=1
+rand_seeded=false
+
+srand()
+{
+ local x="${1}"
+ shift 1
+
+ rand_x=${x}
+ rand_seeded=true
+
+ return 0
+}
+
+rand()
+{
+ # Automatically seed the LCG.
+ if ! ${rand_seeded}; then
+ srand $(expr ${$} + $(date '+%s'))
+ fi
+
+ # Increment, multiplier, and modulus values are those used in glibc.
+ rand_x=$((1103515245 * $rand_x + 12345))
+ rand_x=$(($rand_x % 4294967296))
+
+ return 0
+}